-- See the Copyright notice at the end of this file.
--
class FILE_PROTOCOL
	--
	-- To access to "file://..." URLs
	--

inherit
	PROTOCOL

create {PROTOCOLS}
	make

feature {ANY}
	name: STRING is "file"

	is_connected: BOOLEAN is
		do
			Result := stream.is_connected
		end

	error: STRING

feature {URL}
	connect_to (url: URL) is
		do
			stream.connect_to(url.path)
			if not is_connected then
				error := once ""
				error.copy(once "Cannot read file: ")
				error.append(url.path)
			end
		end

	disconnect is
		do
			stream.disconnect
		end

	input: INPUT_STREAM is
		do
			Result := stream
		end

	output: OUTPUT_STREAM is
		do
			Result := stream
		end

feature {}
	stream: TEXT_FILE_READ_WRITE

	make is
		do
			create stream.make
		end

end -- class FILE_PROTOCOL
--
-- ------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is part of the SmartEiffel standard library.
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
-- documentation files (the "Software"), to deal in the Software without restriction, including without
-- limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
-- the Software, and to permit persons to whom the Software is furnished to do so, subject to the following
-- conditions:
--
-- The above copyright notice and this permission notice shall be included in all copies or substantial
-- portions of the Software.
--
-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO
-- EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
-- AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
-- OR OTHER DEALINGS IN THE SOFTWARE.
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------
