-- This file is part of SmartEiffel The GNU Eiffel Compiler Tools and Libraries.
-- See the Copyright notice at the end of this file.
--
class TEST_BOOLEAN

creation {ANY}
	make

feature {ANY}
	make is
		local
			tr, fr: BOOLEAN
		do
			assert(True)
			assert(not False)
			assert(True = True)
			assert(False = False)
			assert(True = not False)
			assert(True.is_equal(True))
			tr := True
			fr := False
			check
				not tr.is_equal(fr)
				not True.is_equal(False)
			end
			assert(not True.is_equal(False))
			assert(False.is_equal(False))
			assert(False xor True)
			assert(True xor False)
			assert(False implies True)
			assert(False implies never_call)
			assert(never_call_flag = 0)
		end

	never_call: BOOLEAN is
		do
			never_call_flag := never_call_flag + 1
		end

	never_call_flag: INTEGER

	assert (b: BOOLEAN) is
		do
			cpt := cpt + 1
			if not b then
				std_output.put_string("TEST_BOOLEAN: ERROR Test # ")
				std_output.put_integer(cpt)
				std_output.put_string("%N")
			else
				--std_output.put_string("Yes%N");
			end
		end

	cpt: INTEGER

end -- class TEST_BOOLEAN
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- SmartEiffel is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License,
-- as published by the Free Software Foundation; either version 2, or (at your option) any later version.
-- SmartEiffel is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
-- received a copy of the GNU General Public License along with SmartEiffel; see the file COPYING. If not, write to the Free
-- Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
