-- This file is part of SmartEiffel The GNU Eiffel Compiler Tools and Libraries.
-- See the Copyright notice at the end of this file.
--
class TEST_NUMBER01
	--
	-- tests of equality and inequality between integer_64_number
	--

insert
	NUMBER_TOOLS

creation {ANY}
	make

feature {ANY}
	make is
		local
			n1, n2, n3, n4: NUMBER
		do
			-- equality
			n1 := from_integer(-1)
			n2 := from_integer(0)
			n3 := from_integer(1)
			n4 := from_integer(-1)
			assert(n4.is_equal(n1))
			assert(not n4.is_equal(n2))
			assert(not n4.is_equal(n3))
			n4 := from_integer(0)
			assert(n4.is_equal(n2))
			assert(not n4.is_equal(n1))
			assert(not n4.is_equal(n3))
			n4 := from_integer(1)
			assert(n4.is_equal(n3))
			assert(not n4.is_equal(n1))
			assert(not n4.is_equal(n2))
			-- equality with is_equal
			assert(n1.is_equal(n1))
			assert(n2.is_equal(n2))
			assert(not n2.is_equal(n3))
			-- inequality
			assert(n1 < n2)
			assert(n2 < n3)
			assert(n1 < n3)
			assert(n2 > n1)
			assert(n3 > n2)
			assert(n3 > n1)
			assert(n1 <= n2)
			assert(n2 <= n3)
			assert(n1 <= n3)
			assert(n1 <= n1)
			assert(n2 <= n2)
			assert(n3 <= n3)
			assert(n2 >= n2)
			assert(n3 >= n2)
			assert(n3 >= n1)
			assert(n1 >= n1)
			assert(n2 >= n2)
			assert(n3 >= n3)
		end

	count: INTEGER

	assert (b: BOOLEAN) is
		do
			count := count + 1
			if not b then
				io.put_string("TEST_NUMBER01 : ERROR Test # ")
				io.put_integer(count)
				io.put_string("%N")
			end
		end

end -- class TEST_NUMBER01
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- SmartEiffel is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License,
-- as published by the Free Software Foundation; either version 2, or (at your option) any later version.
-- SmartEiffel is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
-- received a copy of the GNU General Public License along with SmartEiffel; see the file COPYING. If not, write to the Free
-- Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
