-- This file is part of SmartEiffel The GNU Eiffel Compiler Tools and Libraries.
-- See the Copyright notice at the end of this file.
--
class TEST_VON_NEUMAN1

creation {ANY}
	make

feature {}
	s: COLLECTION_SORTER[INTEGER_64]

	make is
		local
			tab: ARRAY[INTEGER_64]
		do
			tab := {ARRAY[INTEGER_64] 1, << 9, 5, 3, 2, 1, 3 >> }
			s.von_neuman_sort(tab)
			assert(tab.is_equal({ARRAY[INTEGER_64] 1, << 1, 2, 3, 3, 5, 9 >> }), tab)
			tab.add_last(4)
			s.von_neuman_sort(tab)
			assert(tab.is_equal({ARRAY[INTEGER_64] 1, << 1, 2, 3, 3, 4, 5, 9 >> }), tab)
		end

	assert (b: BOOLEAN; tab: ARRAY[INTEGER_64]) is
		do
			cpt := cpt + 1
			if not b or else not s.is_sorted(tab) then
				std_output.put_string("TEST_VON_NEUMAN_SORT1: ERROR Test # ")
				std_output.put_integer(cpt)
				std_output.put_string("%N")
			end
		end

	cpt: INTEGER

end -- class TEST_VON_NEUMAN1
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- SmartEiffel is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License,
-- as published by the Free Software Foundation; either version 2, or (at your option) any later version.
-- SmartEiffel is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
-- received a copy of the GNU General Public License along with SmartEiffel; see the file COPYING. If not, write to the Free
-- Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
