-- This file is part of SmartEiffel The GNU Eiffel Compiler Tools and Libraries.
-- See the Copyright notice at the end of this file.
--
class DICTIONARY_ITEM

inherit
	HASHABLE
	COMPARABLE

creation {ANY}
	make

feature {ANY}
	hash_code: INTEGER is
		do
			-- Make sure to cause many collisions
			Result := value & 255
		end

	infix "<" (other: like Current): BOOLEAN is
		do
			Result := value < other.value
		end

feature {DICTIONARY_ITEM}
	value: INTEGER

feature {}
	make (value_: like value) is
		do
			value := value_
			trail.add_last(Current)
		end

	trail: FAST_ARRAY[DICTIONARY_ITEM] is
			-- A trail of the DICTIONARY_ITEMS, in the order they were created.
		once
			create Result.with_capacity(1024)
		end

end -- class DICTIONARY_ITEM
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- SmartEiffel is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License,
-- as published by the Free Software Foundation; either version 2, or (at your option) any later version.
-- SmartEiffel is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
-- received a copy of the GNU General Public License along with SmartEiffel; see the file COPYING. If not, write to the Free
-- Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2006: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
