-- This file is part of SmartEiffel The GNU Eiffel Compiler Tools and Libraries.
-- See the Copyright notice at the end of this file.
--
class REQUIRE_ITEM
	--
	-- To one item of a require assertion (see also E_REQUIRE).
	--

inherit
	ASSERTION_LIST

creation {ANY}
	make

feature {ANY}
	compile_to_c (type: TYPE) is
		do
			compile_to_c_(type, False, False)
		end

	accept (visitor: REQUIRE_ITEM_VISITOR) is
		do
			visitor.visit_require_item(Current)
		end

feature {E_REQUIRE}
	non_upper_most_compile_to_c (type: TYPE) is
		local
			i: INTEGER
		do
			from
				i := list.lower
			until
				i > list.upper
			loop
				cpp.pending_c_function_body.extend('(')
				cpp.trace_boolean_expression(type, list.item(i).expression)
				cpp.pending_c_function_body.extend(')')
				i := i + 1
				if i <= list.upper then
					cpp.pending_c_function_body.append(once "&&")
				end
			end
		end

feature {}
	check_assertion_mode: STRING is "req"

end -- class REQUIRE_ITEM
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- SmartEiffel is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License,
-- as published by the Free Software Foundation; either version 2, or (at your option) any later version.
-- SmartEiffel is distributed in the hope that it will be useful but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
-- received a copy of the GNU General Public License along with SmartEiffel; see the file COPYING. If not, write to the Free
-- Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
